import numpy as np
import soundfile as sf
from scipy.signal import stft
from scipy.signal import istft
import matplotlib.pyplot as plt

# Read in audiofiles
observed, samplerate = sf.read('noisy_recording.wav')
noise, samplerate = sf.read('noise_estimate.wav')

# Define parameters
N_FFT          = 256
frameshift     =  64
max_att        =  12
att_lin = 10.0**(-max_att/20.0)
overest        =   5

# STFT of observed signal
f_y, t_y, s_y = stft(observed,fs=samplerate,nperseg=N_FFT,noverlap=N_FFT-frameshift)
plt.pcolormesh(t_y,f_y,20*np.log10(np.abs(s_y)))
plt.show(block='True')

# STFT of noise signal
f_b, t_b, s_b= stft(noise,fs=samplerate,nperseg=N_FFT,noverlap=N_FFT-frameshift)
plt.pcolormesh(t_b,f_b,20*np.log10(np.abs(s_b)))
plt.show(block='True')

# Assume stationary noise statistics for PSD coumputation
# Use entire signal

S_bb = 
          
# Compute output spectrum
s_s_hat = np.zeros(np.shape(s_y),dtype=np.complex_)

for k in range(0,np.size(t_y)):
    # Filter characteristic
    H = 
    # Apply
    s_s_hat[:,k] = 

# Synthesis
t,s_hat = 

# Plot time signals
plt.plot(observed,label='observed')
plt.plot(s_hat,label='estimated')
plt.legend()
plt.show(block='True')

# Write audio file
sf.write('estimated.wav',s_hat,samplerate)